*******************************************************************************
*                      68000/68010 Grundprogramm sound                        *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2007 Jens Mewes                                 *
*                                 Rev 7.00                                    *
*                                01.09.2007                                   *
*                         Speak- und Sound-Routinen                           *
*******************************************************************************



sprachein:
 clr.b spra0.w                  * Stop
 move.b #$50,spra1.w            * Defaultwerte fr sinnvolle Sprache
 move.b #$a8,spra2.w
 move.b #$5c,spra3.w
 move.b #$e9,spra4.w
rts

speak:
 movem.l d0/a0,-(a7)
 bsr.s sprachein                * Voreinstellungen
 move (a0)+,d0                  * Anzahl laden
 subq #1,d0                     * Wegen DBRA
spk0lp:
 tst.b spra0.w
 bpl.s spk0lp                   * Bit 7 = 1, dann fertig
 move.b (a0)+,spra0.w           * Werte bertragen
 move.b (a0)+,spra1.w
 move.b (a0)+,spra2.w
 move.b (a0)+,spra3.w
 move.b (a0)+,spra4.w
dbra d0,spk0lp                  * Nchster Wert
 movem.l (a7)+,d0/a0
rts

speak1:
 movem.l d0/a0,-(a7)
 bsr.s sprachein                * Voreinstellungen
 move (a0)+,d0                  * Anzahl Bytes
 subq #1,d0                     * Wegen Dbra
spk1lp:
 tst.b spra0.w
 bpl.s spk1lp                   * Bit 7 = 1, dann fertig
 move.b (a0)+,spra0.w           * Wert bertragen
dbra d0,spk1lp                  * Nchster Wert
 movem.l (a7)+,d0/a0
rts

sound:
 move.l d0,-(a7)
 moveq #16-1,d0                 * Anzahl der Parameter
 lea 16(a0),a0                  * Von hinten bertragen
sound1:
 move.b d0,snd0.w               * Nummer Port
 move.b -(a0),snd1.w            * Byte bertragen
dbra d0,sound1
 move.l (a7)+,d0
rts

